
#pragma once

#include <stdio.h>
#include <string.h>
#include <malloc.h> // for _alloca (allocation on stack)


///////////////////////////HASH CODE TABLE ////////////////////////////////////////////////

typedef struct {
  LPTSTR name;
  void *ptr;
} XMLNAMED;

typedef struct {
  XMLNAMED **v;
  size_t size;
  size_t used;
  size_t usedLim;
} XMLHASH_TABLE;

typedef struct {
  XMLNAMED **p;
  XMLNAMED **end;
} XMLHASH_TABLE_ITER;





// simple StringManager implementation ////////////////////////////

class StringManager
{
protected:
	XMLHASH_TABLE m_hashTable;

public:
	StringManager();
	virtual ~StringManager();

	void Init();
	void Destroy();

	LPTSTR GetPtr(LPTSTR); // add or get ptr
	LPTSTR GetCaselessPtr(LPTSTR); // add or get ptr
};





LPTSTR XmlhashTableLookup(XMLHASH_TABLE *table, const LPTSTR name, const void *ptr, BOOL bCaseSensitive);
void XmlhashTableInit(XMLHASH_TABLE *);
void XmlhashTableDestroy(XMLHASH_TABLE *);

long XmlhashTableSize(XMLHASH_TABLE *p);
XMLNAMED *XmlhashTableFirstItem(XMLHASH_TABLE_ITER *iter, XMLHASH_TABLE *p);
XMLNAMED *XmlhashTableNextItem(XMLHASH_TABLE_ITER *iter, XMLHASH_TABLE *p);







